import express from 'express';
import { isAuthenticated } from '../../keycloak.js';

const router = express.Router();
import {
  listJobsRouteHandler,
  listJobsByPropertiesRouteHandler,
  getJobRouteHandler,
  newJobRouteHandler,
  deleteJobRouteHandler,
  getJobStatsRouteHandler,
  getJobHistoryRouteHandler,
} from '../../services/production/jobs.js';
import { convertPropertiesString, getFilter } from '../../utils.js';

// list of jobs
router.get('/', isAuthenticated, (req, res) => {
  const { page, limit, property, search, sort, order } = req.query;
  const allowedFilters = ['state'];
  const filter = getFilter(req.query, allowedFilters);
  listJobsRouteHandler(req, res, page, limit, property, filter, search, sort, order);
});

router.get('/properties', isAuthenticated, (req, res) => {
  let properties = convertPropertiesString(req.query.properties);
  const allowedFilters = ['state'];
  const filter = getFilter(req.query, allowedFilters, false);
  listJobsByPropertiesRouteHandler(req, res, properties, filter);
});

router.post('/', isAuthenticated, (req, res) => {
  newJobRouteHandler(req, res);
});

// get job stats
router.get('/stats', isAuthenticated, (req, res) => {
  getJobStatsRouteHandler(req, res);
});

// get job history
router.get('/history', isAuthenticated, (req, res) => {
  getJobHistoryRouteHandler(req, res);
});

router.get('/:id', isAuthenticated, (req, res) => {
  getJobRouteHandler(req, res);
});

router.delete('/:id', isAuthenticated, async (req, res) => {
  deleteJobRouteHandler(req, res);
});

export default router;
